/**************************************************************

   Program Title:  Wasp AVR Boot/Monitor
   
   Program Name:  Wasp_Extern.h		      Version: 0.92
   
   Author:  SS	  					  Date:  June 11, 2010
   
   Compiled with ImageCraft ICCAVR Standard V7.20.
   
   Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2009 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */
/*
 * $Log: Wasp_Extern.c,v $
 * Revision 0.85  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  Variable declarations
extern unsigned int bytesonline;
extern unsigned char programmode,crc,intelbinary[34];  // length can vary
extern unsigned char hexbyte[3],hexaddress[5],intelrecordcommand;
extern unsigned char seconds,minutes,hours,days,rtcclockcnt,loggingmode;
extern unsigned char flashtype0,flashtype1,flashpageloaded,data2log;
extern unsigned char flashprogrammingactive,flashpageboundarytraversed;
extern unsigned char flashprogrammingactive,flashdatainbuffer,ascii[16],flashbuffer;
extern unsigned char version[30],i2cmode,armpd2,smartlcdstate,digitalcompassstate,ADSstate;
extern unsigned char TWI_slaveAddress,TWI_masterAddress;
extern unsigned char deviceidtext[21],terminationmode,rtccnt;

extern unsigned int flashpagesize0,flashpagesize1,pagecnt,timeoutperiod,elapsedtime;
extern unsigned int intelsuperaddress,oldpage,oldbyteoffset,totalrxcnt;
extern unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
extern unsigned int mseccountdown1,mseccountdown2,mseccountdown3,flashcountdown;

extern unsigned char messageBuf[TWIMESSAGELENGTH],BMPstate,deviceid,dataformat;

// BMP085 Parameters
extern int  bmpac1,bmpac2,bmpac3,bmpb1,bmpb2,bmpmb,bmpmc,bmpmd;
extern unsigned int bmpac4,bmpac5,bmpac6;

// L3G4200D parameters
extern unsigned char dof10wmode,l3g4200dstate;

// HMC5883 parameters
extern unsigned char hmc5883state;

extern unsigned int totalbytecnt,xoncnt,xoffcnt;
extern unsigned char frameerror,dataoverrun;
extern int cursorlocation,defaultlograte;
extern int xgmax,xgmin,xgmid,ygmax,ygmin,ygmid,zgmax,zgmin,zgmid;
extern long flashaddress,inteladdress,oldinteladdress;

extern int _textmode;

/* Static Variables */
extern unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
extern unsigned char UART_RxHead;
extern unsigned char UART_RxTail;
extern unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
extern unsigned char UART_TxHead;
extern unsigned char UART_TxTail;
extern char  xoffsent, xonsent, enablexonoff, echoinchars, sendxoff;
extern char  rxcnt,checkflag,rxcntmax;
extern unsigned char  instrg[8],vlow,vhigh,defaultaccelerometerrange,logoutputmode;

extern unsigned char FlashAddress[3];
extern const char signon1[];
extern const char signon2[];
extern const char signon3[];
extern const char signon4[];
extern const char signon5[];
extern const char signon6[];
extern const char signon62[];
extern const char signon65[];
extern const char signon66[];
extern const char signon67[];
extern const char signon7[];
extern const char signon8[];
extern const char signon83[];
extern const char signon85[];
extern const char signon9[];
extern const char signon10[];

extern const char displaymessage1[];
extern const char displaymessage2[];
extern const char displaymessage3[];
extern const char displaymessage33[];

extern const char progmessage[];

extern const char displaymessage4[];
extern const char displaymessage5[];
extern const char displaymessage6[];

extern const char loadmessage1[];
extern const char loadmessage2[];
extern const char loadmessage3[];

extern const char enummes1[];
extern const char enummes8[];
extern const char enummes9[];
extern const char enummes10[];
extern const char enummes11[];
extern const char enummes12[];
extern const char enummes13[];
extern const char enummes14[];
extern const char enummes15[];
extern const char enummes16[];
extern const char enummes17[];

// Function declarations
//extern unsigned char EEPROMwrite(int,unsigned char);
//extern unsigned char EEPROMread(int);
extern int printf(CONST char *, ...);
extern int sprintf(char *, CONST char *, ...);
extern int scanf(CONST char *, ...);
extern int sscanf(char *, CONST char *, ...);

extern void InitUART(unsigned char baudrate);
extern void InitADC(void);
extern void InitRealTimeClock(void);
extern void Init_Timer0(void);
extern void InitWatchdog(void);
extern void Init_SPI_Master(void);
extern void Init_AVR(void);
extern void Delay(void);
extern void shortdelay(int cnt);
extern void LongDelay(int cnt);
extern void Delaymsec(int delayvalue);
extern void GREEN_LED(unsigned char mode);
extern void RED_LED(unsigned char mode);
extern void WriteEEPROM(int location, unsigned char *strg);
extern void BlinkGreen(int period);
extern void BlinkRed(int period);
extern void PiranaMorse(void);
extern void EEPROMSetup(void);
extern void getsettime(void);
extern char getint(void);
extern unsigned char ReadAVRFlash(int address);
extern void signon(void);
extern void DisplayEEPROM(int address,int numbytes);
extern void DisplayAVRFlash(int address,int numbytes);
extern void DisplayMemory(void);
extern void DebugDisplayIntelHex(void);
extern int checkcrc(unsigned char);
extern int DecodeIntelHex(void);
extern void ProgramEEPROM(void);
extern void ProgramAVRFlash(void);
extern void ProgramMemory(void);
extern void FlashChipSelect(unsigned char mode);
extern void LoadMemory(void);
extern void ProgramVersion(void);
extern void PrintHex(unsigned char);
extern int  AnalogCh(int ch,char mode);
extern void DumpAnalogChs(void);
extern void TestAVR(void);
extern void Release_SPI(void);
extern void SPI_MasterTransmit(unsigned char cData);
extern unsigned char SPI_MasterReceive(void);
extern void ConvertFlashAddress(long address);
extern void SPI_StartReadFlashPage(unsigned int address);
extern void SPI_ReadFlashBuffer(unsigned int address,unsigned int buffernumber);
extern void EraseFlashPage(void);
extern void ProgramBuffertoPageErase(unsigned char bufferid);
extern void DisplaySerialFlash(unsigned int address,
                            unsigned int numbytes,char readmode);
extern void ProgramSerialFlash(void);
extern unsigned char SPI_SerialFlashStatus(void);
extern void CleanUpFlashState(void);
extern void Init_TWI_Master(void);
extern void Init_TWI_Slave(unsigned char slaveaddress,char generalcall);
extern void TWI_Error(void);
extern void TWI_Off(void);
extern unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
                            unsigned char statusmode);
extern unsigned char TWI_Master_Receive(unsigned char slaveaddress);
extern void TestTWI(void);
extern void TWI_Write_Slave(void);
extern unsigned char getcharnw(void);
extern void InittUART(unsigned char baudrate);
extern unsigned char ReceiveByte(void);
extern void TransmitByte(unsigned char data);
extern unsigned char getuchar(void);
extern int putuchar(unsigned char data);
//extern unsigned char getchar(void);
//extern void printint(int intvalue,char charcnt,char leadchartype);
extern void putus(char *outstrg);
extern void putCRLF(void);
extern void putfs(const char *signon1);
extern void bytetohex(unsigned char byte);
extern void addresstohex(unsigned int address);
extern unsigned char converttohex(char *instrg);
extern int readint(void);
extern void Init_3Axis_Accelerometer(char);
extern void putcharr(char);
extern char getcharr(void);
extern void Display_Gravity(void);
extern void WaitForFlashFree(void);
extern int putchar(char);
extern void PrintWordHex(unsigned int);

// Nokia LCD externals
extern void Initialize_Nokia_LCD(void);
extern void Draw_Color_Bars(unsigned char color);
extern void Draw_Boxes(unsigned char color);
extern void Draw_Background(unsigned char color);
extern void Nokia_LCD_LED(unsigned char state);
extern void Nokia_LCD_ContrastUp(void);
extern void Nokia_LCD_ContrastDown(void);
extern unsigned char Read_Switched(void);
extern void ProcessLCDCommands(unsigned char);

extern void CheckFlashTypes(void);
extern void ChipErase(void);

extern void SaveEepromPreferences(void);
extern void LoadEepromPreferences(void);
extern float ReadEepromFloat(int address);
extern void  WriteEepromFloat(int address,float fvalue);
extern int ReadEepromInt(int address);
extern unsigned char CheckEepromSignature(void);
extern void WriteCopyright(void);
extern void WriteVersion(void);
extern void WriteEepromInt(int address,int ivalue);
extern void WriteEepromSignature(void);
extern unsigned char EEPROM_read(int uiAddress);
extern void  EEPROM_write(int uiAddress,unsigned char ucData);

// TWI Extern Functions
extern void TWI_Master_Initialise(void);
extern unsigned char TWI_Transceiver_Busy(void);
extern unsigned char TWI_Get_State_Info(void);
extern void TWI_Start_Transceiver_With_Data(unsigned char * , unsigned char);
extern void TWI_Start_Transceiver(void);
extern unsigned char TWI_Get_Data_From_Transceiver(unsigned char *,unsigned char);
extern unsigned char TWI_Start_Read(unsigned char address,unsigned char msgSize);
extern void TWI_Start_Write(unsigned char address,unsigned char *msg,unsigned char msgSize);
extern void TWI_Master_Initialize(void);

extern void Display_SmartLCD(void);
extern void putcharSmartLCD(char);
extern void putsSmartLCD(char *);
extern void ClearSmartLCD(void);
extern void Enumerate_TWI_Devices(void);
extern void Execute_TWI_Command(void);
extern unsigned char Read_BMP085_EEPROM(unsigned char);
extern unsigned int Read_BMP085_Pressure(void);
extern unsigned int Read_BMP085_Temperature(void);
extern float Read_BMP085_pressurefloat(char);
extern void Load_BMP085_Parameters(void);
extern int Read_BMP085_EEPROM_Signed(unsigned char);
extern void EnableBMP085(char);
extern unsigned int Read_BMP085_EEPROM_UnSigned(unsigned char);
extern void Enumerate_ADS(void);
extern void Enumerate_DigitalCompass(void);
extern unsigned int Read_ADS1100(void);
extern long int Read_caliper(void);

extern unsigned char Read_HMC5883_Register(unsigned char);
extern void Write_HMC5883_Register(unsigned char,unsigned char);
extern void Enumerate_BMP085(void);
extern void Enumerate_HMC5883(void);
extern void Init_SmartLCD_TWI(unsigned char);






