	.module Wasp_Init.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Init.c
	.dbfunc e InitUART _InitUART fV
;              x -> R10
;       baudrate -> R16
	.even
_InitUART::
	st -y,R10
	.dbline -1
	.dbline 76
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_Init.c		  Version: 0.93
;    
;    Author:  SS	  					  Date:  June 11, 2010
;    
;    Compiled with ImageCraft ICCAVR Standard V7.20.
;    
;    This file contains routines that implement the basic initialization 
;    routines for the Wasp AVR Monitor.
;    
;    Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Init.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; //****************************************************************
; //****************************************************************
; // Initialization code
; //****************************************************************
; //****************************************************************
; 
; // Initialize UART
; void InitUART(unsigned char baudrate)
; {
	.dbline 80
; 	unsigned char x;
; 	
; 	// Set the baud rate
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 81
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline 83
; 	// Enable UART receiver and transmitter
; 	UCSR0B = BIT(RXCIE0)|BIT(UDRIE0)|BIT(RXEN0)|BIT(TXEN0); 
	ldi R24,184
	sts 193,R24
	.dbline 85
;     //  8 data bits, 1 stop bit, no parity
; 	UCSR0C = (3<<UCSZ00)|(1<<USBS0);
	ldi R24,14
	sts 194,R24
	.dbline 87
; 
; 	x = 0; // flush receive buffer
	clr R10
	.dbline 88
; 	rxcnt = x; // rx buffer empty
	sts _rxcnt,R10
	.dbline 89
; 	xoffsent = NO;
	sts _xoffsent,R2
	.dbline 90
; 	sendxoff = NO;
	sts _sendxoff,R2
	.dbline 91
; 	xonsent = NO;
	sts _xonsent,R2
	.dbline 92
; 	checkflag = NO;
	sts _checkflag,R2
	.dbline 93
; 	enablexonoff = YES; // turn serial driver xon/xoff flow control on
	ldi R24,1
	sts _enablexonoff,R24
	.dbline 94
; 	echoinchars = NO;   // echo all received characters
	sts _echoinchars,R2
	.dbline 95
; 	UART_RxTail = x;
	sts _UART_RxTail,R10
	.dbline 96
; 	UART_RxHead = x;
	sts _UART_RxHead,R10
	.dbline 97
; 	UART_TxTail = x;
	sts _UART_TxTail,R10
	.dbline 98
; 	UART_TxHead = x;
	sts _UART_TxHead,R10
	.dbline 99
; 	dataoverrun = NO;
	sts _dataoverrun,R2
	.dbline 100
; 	frameerror = NO;
	sts _frameerror,R2
	.dbline 101
; 	xoncnt = 0;
	clr R3
	sts _xoncnt+1,R3
	sts _xoncnt,R2
	.dbline 102
; 	xoffcnt = 0;
	sts _xoffcnt+1,R3
	sts _xoffcnt,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r x 10 c
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e InitADC _InitADC fV
	.even
_InitADC::
	.dbline -1
	.dbline 108
; }
; 
; //  Setup the Analog to Digital converter
; //  TBD - convert to background interrupt process
; void InitADC(void)
; {
	.dbline 109
; 	DDRA = 0x00;  // All inputs
	clr R2
	out 0x1,R2
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitRealTimeClock _InitRealTimeClock fV
	.even
_InitRealTimeClock::
	.dbline -1
	.dbline 118
; 		   		  // Setup Analog TDB
; }
; 
; //  Start the real time clock 
; //  Clocked by external 32.768KHz watch crystal
; //  Set prescalar to 0, set to interrupt using compare match 
; //  set to 128 (4msec interrupt rate).  
; void InitRealTimeClock(void)
; {  
	.dbline 120
;     // Software counters - approximately 4msec resolution
; 	rtccountdown1 = 0;  
	clr R2
	clr R3
	sts _rtccountdown1+1,R3
	sts _rtccountdown1,R2
	.dbline 121
; 	rtccountdown2 = 0;
	sts _rtccountdown2+1,R3
	sts _rtccountdown2,R2
	.dbline 122
; 	rtccountdown3 = 0;
	sts _rtccountdown3+1,R3
	sts _rtccountdown3,R2
	.dbline 123
; 	rtccountdown4 = 0;
	sts _rtccountdown4+1,R3
	sts _rtccountdown4,R2
	.dbline 124
; 	rtcclockcnt = 0;
	sts _rtcclockcnt,R2
	.dbline 125
; 	seconds = 0;
	sts _seconds,R2
	.dbline 126
; 	minutes = 0;
	sts _minutes,R2
	.dbline 127
; 	hours = 0;
	sts _hours,R2
	.dbline 128
; 	days = 0;
	sts _days,R2
	.dbline 130
; 	
;  	TCNT2 = 0;
	sts 178,R2
	.dbline 132
;  	// Select external real time clock oscillator
; 	ASSR = (1<<AS2);
	ldi R24,32
	sts 182,R24
	.dbline 134
; 	// Set match interrupt to 4msec
; 	OCR2A = 127;
	ldi R24,127
	sts 179,R24
	.dbline 136
; 	// Reload counter on match interrupt - pre-scalar set to 0
; 	TCCR2A = (1<<WGM21);   
	ldi R24,2
	sts 176,R24
	.dbline 137
; 	TCCR2B = (1<<CS20);   
	ldi R24,1
	sts 177,R24
	.dbline 139
;     // setup interrupts for real time clock
;     TIMSK2 |= (1<<OCIE2A);
	lds R24,112
	ori R24,2
	sts 112,R24
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_Timer0 _Init_Timer0 fV
	.even
_Init_Timer0::
	.dbline -1
	.dbline 145
; }
; 
; // Timer2 is called every 1msec - used to maintain four count down 
; // software timers to control precise time delays in various routines
; void Init_Timer0(void)
; {
	.dbline 146
;  	 mseccountdown1 = 0;
	clr R2
	clr R3
	sts _mseccountdown1+1,R3
	sts _mseccountdown1,R2
	.dbline 147
; 	 mseccountdown2 = 0;
	sts _mseccountdown2+1,R3
	sts _mseccountdown2,R2
	.dbline 148
; 	 mseccountdown3 = 0;
	sts _mseccountdown3+1,R3
	sts _mseccountdown3,R2
	.dbline 149
; 	 flashcountdown = 0;
	sts _flashcountdown+1,R3
	sts _flashcountdown,R2
	.dbline 151
; 	 
; 	 TCNT0 = 0;
	out 0x26,R2
	.dbline 153
; 	 // Set mode 2 - reset counter on compare match, clk/64
; 	 TCCR0A = (1<<WGM01);
	ldi R24,2
	out 0x24,R24
	.dbline 154
; 	 TCCR0B = (1<<WGM01)|(1<<CS01)|(1<<CS00);
	ldi R24,3
	out 0x25,R24
	.dbline 157
; 	 
; 	 // Reset count after 1 msec (8MHz clock)
; 	 OCR0A = 125;
	ldi R24,125
	out 0x27,R24
	.dbline 160
; 	 
; 	 // Reset count after 1 msec (10MHz clock)
; 	 OCR0A = 156;
	ldi R24,156
	out 0x27,R24
	.dbline 163
; 	 	 
; 	 // Enable compare match interrupt vector
; 	 TIMSK0 |= (1<<OCIE0A);
	lds R24,110
	ori R24,2
	sts 110,R24
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitWatchdog _InitWatchdog fV
	.even
_InitWatchdog::
	.dbline -1
	.dbline 168
; }
; 
; // Setup watch dog timer - TBD
; void InitWatchdog(void)
; {
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_SPI_Master _Init_SPI_Master fV
	.even
_Init_SPI_Master::
	.dbline -1
	.dbline 172
; }
; 
; void Init_SPI_Master(void)
; {
	.dbline 175
;     // Set MOSI and SCK output, all others input
; //	DDRB = (1<<PB5)|(1<<PB7)|(1<<PB4);
; 	DDRB |= ((1<<PB5)|(1<<PB7)|(1<<PB4));
	in R24,0x4
	ori R24,176
	out 0x4,R24
	.dbline 176
; 	PORTB |= 0xAC;  // Set bits MOSI & SCK
	in R24,0x5
	ori R24,172
	out 0x5,R24
	.dbline 180
; 	
; 	// Enable SPI, Master, set clock rate fck
; 	//    Select SPI Mode 3 - CPOL=1, CPHA=1
; 	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR0);
	ldi R24,93
	out 0x2c,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_AVR _Init_AVR fV
	.even
_Init_AVR::
	.dbline -1
	.dbline 189
; //	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0);
; //	SPCR = 0x91;
; }
; 
; //************************************************************
; //  Initialize the AVR - set port conditions for Blackfin
; //************************************************************
; void Init_AVR(void)
; {
	.dbline 191
;     // Setup serial flash constants and variables
; 	programmode = LFLASH;  // programming serial flash - default
	ldi R24,102
	sts _programmode,R24
	.dbline 192
; 	flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 193
; 	flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 194
; 	flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 195
; 	flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 196
; 	intelsuperaddress = 0;
	clr R3
	sts _intelsuperaddress+1,R3
	sts _intelsuperaddress,R2
	.dbline 197
; 	oldpage = 0;
	sts _oldpage+1,R3
	sts _oldpage,R2
	.dbline 198
; 	oldbyteoffset = 0;
	sts _oldbyteoffset+1,R3
	sts _oldbyteoffset,R2
	.dbline 201
; 	
;     // Setup Port A
; 	InitADC();
	xcall _InitADC
	.dbline 208
; 	
; 	// Setup Port B
; 	//   PB0 - NC
; 	//   PB1 - ADXL345 CS
; 	//   PB2 - L3G4200 CS
; 	//   PB4 - SS
; 	DDRB = 0x16;
	ldi R24,22
	out 0x4,R24
	.dbline 209
; 	PORTB |= 0x16;  // If ADXL345 attached PB1 is chip select set high
	in R24,0x5
	ori R24,22
	out 0x5,R24
	.dbline 217
; 	
; 	// Setup Port C
; 	//   Wasp A - Switch control pins:  PC2-CLK, PC3-DIN
; 	//            MMA7206  SLP  PC3 - Must be high to turn on accelerometer
; 	//            PC0 is SCL - must be output
; 	//            PC1 is SDA
; 	//DDRC = 0x04;
; 	DDRC = 0x05;
	ldi R24,5
	out 0x7,R24
	.dbline 218
; 	PORTC = 0x01;
	ldi R24,1
	out 0x8,R24
	.dbline 234
; 	
; 	// Setup Port D
; 	//   Wasp A - Switch control pins:  PC2-CLK, PC3-DIN, PD3-Load
; 	//   Wasp B - Switch control pins:  PD6-CLK, PD7-DIN, PD3-Load
; 	//   Use PD6 and PD7 to control the reset lines on two BMP085
; 	//   barometric pressure sensors
; 	//   DOF10W Pin assignments:
; 	//     PD2 - Mag DRDY
; 	//     PD6 - Gyro INT2
; 	//     PD7 - Accel INT2
; 	//     PD5 - Red LED
; 	//     PD4 - Green LED
; //	DDRD = 0xf0;   // For dual DMP085
; //	DDRD = 0x70;   // For dual DMP085
; //	DDRD = 0x3C;   // For Wasp A
;     DDRD = 0x30;
	ldi R24,48
	out 0xa,R24
	.dbline 242
; //	ClrBit(PORTD,PIND2);  // Turn LCD off if attached
; 
; 	
; 	//   Setup SPI - SPI default inactive in this release
; //    Init_SPI_Master();
; 	
; 	//    Turn on real time clock on PC7,6 Timer/Counter 2
; 	InitRealTimeClock();
	xcall _InitRealTimeClock
	.dbline 247
; 	
; 	// Setup Timer 0 to interrupt a 1msec rate - this interrupt
; 	// controls four software delay timers used by various 
; 	// routines
; 	Init_Timer0();
	xcall _Init_Timer0
	.dbline 250
; 	
; 	// Turn LEDs off
; 	RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 251
; 	GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 269
; 	
; 	// Watchdog timer setup
; //	InitWatchdog();
; 	
; 	// Initialize UART - Interrupt
; 	// Set the baudrate to 9,600 bps using an 8MHz clock
; #ifdef C10MCLOCK
; //	InitUART(BAUDRATE9600); 
; //  InitUART(BAUDRATE19200);
; //    InitUART(BAUDRATE38400); 
;     InitUART(BAUDRATE57600); 
; //  InitUART(BAUDRATE115200); 
; #endif
; #ifdef C11MCLOCK
; //	InitUART(BAUDRATE9600); 
; //  InitUART(BAUDRATE19200);
; //  InitUART(BAUDRATE57600); 
;     InitUART(BAUDRATE115200);
	ldi R16,5
	xcall _InitUART
	.dbline 277
; //	InitUART(BAUDRATE230400); 
; #endif
; 
; 	// Initialize digitcal compass
; 	//Enumerate_DigitalCompass();
; 	
;     // System logging parameters
; 	defaultlograte = 5;
	ldi R24,5
	ldi R25,0
	sts _defaultlograte+1,R25
	sts _defaultlograte,R24
	.dbline 278
; 	defaultaccelerometerrange = G15MODE;
	ldi R24,49
	sts _defaultaccelerometerrange,R24
	.dbline 279
; 	logoutputmode = PROCESSED;
	ldi R24,112
	sts _logoutputmode,R24
	.dbline 280
; 	armpd2 = YES;
	ldi R24,1
	sts _armpd2,R24
	.dbline 281
; 	armpd2 = NO;
	clr R2
	sts _armpd2,R2
	.dbline 282
; 	terminationmode = BUTTON;
	ldi R24,98
	sts _terminationmode,R24
	.dbline 283
; 	terminationmode = TIMEOUT;
	ldi R24,116
	sts _terminationmode,R24
	.dbline 284
; 	timeoutperiod = 140;  // seconds
	ldi R24,140
	sts _timeoutperiod+1,R25
	sts _timeoutperiod,R24
	.dbline 285
; 	data2log = 'a';
	ldi R24,97
	sts _data2log,R24
	.dbline 286
; 	dataformat = PROCESSED;
	ldi R24,112
	sts _dataformat,R24
	.dbline 287
; 	strcpy(deviceidtext,"Wasp Logger V0.95 A");
	ldi R18,<L8
	ldi R19,>L8
	ldi R16,<_deviceidtext
	ldi R17,>_deviceidtext
	xcall _strcpy
	.dbline 288
; 	rtccnt = NO;
	clr R2
	sts _rtccnt,R2
	.dbline 294
; 	//dataformat = PROCESSED;
; //	deviceid = LEFTARM;
; //	deviceid = RIGHTARM;
; //	deviceid = UPPERSPINE;
; //	deviceid = LOWERSPINE;
; 	deviceid = SLED;
	ldi R24,115
	sts _deviceid,R24
	.dbline 297
; 
; 	// Accelerometer calibration parameters
; 	xgmin = 295;
	ldi R24,295
	ldi R25,1
	sts _xgmin+1,R25
	sts _xgmin,R24
	.dbline 298
; 	xgmax = 791;
	ldi R24,791
	ldi R25,3
	sts _xgmax+1,R25
	sts _xgmax,R24
	.dbline 299
; 	xgmid = 560;
	ldi R24,560
	ldi R25,2
	sts _xgmid+1,R25
	sts _xgmid,R24
	.dbline 300
; 	ygmin = 275;
	ldi R24,275
	ldi R25,1
	sts _ygmin+1,R25
	sts _ygmin,R24
	.dbline 301
; 	ygmax = 789;
	ldi R24,789
	ldi R25,3
	sts _ygmax+1,R25
	sts _ygmax,R24
	.dbline 302
; 	ygmid = 560;
	ldi R24,560
	ldi R25,2
	sts _ygmid+1,R25
	sts _ygmid,R24
	.dbline 303
; 	zgmin = 306;
	ldi R24,306
	ldi R25,1
	sts _zgmin+1,R25
	sts _zgmin,R24
	.dbline 304
; 	zgmax = 807;
	ldi R24,807
	ldi R25,3
	sts _zgmax+1,R25
	sts _zgmax,R24
	.dbline 305
; 	zgmid = 570;
	ldi R24,570
	ldi R25,2
	sts _zgmid+1,R25
	sts _zgmid,R24
	.dbline 308
; 	
; 	// DOF10W settings
; 	dof10wmode = ACTIVE;
	ldi R24,97
	sts _dof10wmode,R24
	.dbline 309
; 	l3g4200dstate = 0;
	sts _l3g4200dstate,R2
	.dbline 310
; 	hmc5883state = 0;
	sts _hmc5883state,R2
	.dbline 313
; 
; 	// I2C Mode Settings
; 	i2cmode = ACTIVE;
	sts _i2cmode,R24
	.dbline 314
; 	TWI_slaveAddress = TWI_SLAVEADDRESS;
	ldi R24,8
	sts _TWI_slaveAddress,R24
	.dbline 315
; 	TWI_masterAddress = TWI_MASTERADDRESS;
	ldi R24,9
	sts _TWI_masterAddress,R24
	.dbline 320
; 
; 	// See if signature bytes are loaded into EEPROM - if 
; 	// not there then write sig bytes and default preferences
; 	// otherwise load preferences
; 	if(!CheckEepromSignature())  {
	xcall _CheckEepromSignature
	tst R16
	brne L9
X0:
	.dbline 320
	.dbline 322
; 	    //printf("EEPROM contents not set\n\r");
; 	    WriteEepromSignature();
	xcall _WriteEepromSignature
	.dbline 323
; 		WriteVersion();
	xcall _WriteVersion
	.dbline 324
; 		WriteCopyright();
	xcall _WriteCopyright
	.dbline 325
; 	    SaveEepromPreferences();
	xcall _SaveEepromPreferences
	.dbline 326
; 	 	}
	xjmp L10
L9:
	.dbline 327
; 	else LoadEepromPreferences();
	xcall _LoadEepromPreferences
L10:
	.dbline 330
; 
; 	// Enable TWI if active
; 	if(i2cmode==ACTIVE)  
	lds R24,_i2cmode
	cpi R24,97
	brne L11
X1:
	.dbline 331
; 	    TWI_Master_Initialize();
	xcall _TWI_Master_Initialize
L11:
	.dbline -2
L7:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Init.c
L8:
	.blkb 20
	.area idata
	.byte 'W,'a,'s,'p,32,'L,'o,'g,'g,'e,'r,32,'V,48,46,57
	.byte 53,32,'A,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Init.c
; //	    TWI_Master_Initialize(TWI_masterAddress,TWI_GENERAL_CALL_ON,0x00);
; 					
; }
