	.module Wasp_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_Utilities.c	Version: 0.92
;    
;    Author:  SS	  					  Date:  June 11, 2010
;    
;    Compiled with ImageCraft ICCAVR Standard V7.20.
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the Wasp Monitor.
;    
;    Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Utilities.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, 19,200baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e shortdelay _shortdelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_shortdelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void shortdelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e RED_LED _RED_LED fV
;           mode -> R16
	.even
_RED_LED::
	.dbline -1
	.dbline 107
; }
; 
; void RED_LED(unsigned char mode)
; {
	.dbline 108
;  	if(mode==ON) ClrBit(PORTD,PIND5);	// low output to turn LED on
	tst R16
	brne L24
X5:
	.dbline 108
	cbi 0xb,5
	xjmp L25
L24:
	.dbline 109
; 	else SetBit(PORTD,PIND5);	// low output to turn LED off
	sbi 0xb,5
L25:
	.dbline -2
L23:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e GREEN_LED _GREEN_LED fV
;           mode -> R16
	.even
_GREEN_LED::
	.dbline -1
	.dbline 113
; }
; 
; void GREEN_LED(unsigned char mode)
; {
	.dbline 114
;  	 if(mode==ON) ClrBit(PORTD,PIND4);	
	tst R16
	brne L27
X6:
	.dbline 114
	cbi 0xb,4
	xjmp L28
L27:
	.dbline 115
; 	 else SetBit(PORTD,PIND4);	
	sbi 0xb,4
L28:
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 122
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 124
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 125
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 126
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 127
; 	CLI();													// disable interrupts
	cli
	.dbline 128
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 129
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 130
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 131
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L29:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 137
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 138
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L31
X7:
	ldi R16,1
	ldi R17,0
	xjmp L32
L31:
	clr R16
	clr R17
L32:
	.dbline -2
L30:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 144
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L34:
	.dbline 145
;  	 while(!RTEEPROMReady())  ;
L35:
	.dbline 145
	xcall _RTEEPROMReady
	tst R16
	breq L34
X8:
	.dbline 146
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L37:
	.dbline 147
;  	 while(!RTEEPROMReady())  ;
L38:
	.dbline 147
	xcall _RTEEPROMReady
	tst R16
	breq L37
X9:
	.dbline -2
L33:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e WriteEEPROM _WriteEEPROM fV
;              i -> R20,R21
;           strg -> R10,R11
;       location -> R12,R13
	.even
_WriteEEPROM::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	.dbline -1
	.dbline 152
; }
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg)
; {
	.dbline 155
;  	 int i;
; 	 
; 	 i = 0;
	clr R20
	clr R21
	xjmp L42
L41:
	.dbline 156
; 	 while(strg[i] != 0x00)  {
	.dbline 157
; 	     EEPROMWrite(location+i,strg[i]);
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R18,z+0
	movw R16,R12
	add R16,R20
	adc R17,R21
	xcall _EEPROMWrite
	.dbline 158
; 		 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 159
; 		 }
L42:
	.dbline 156
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L41
X10:
	.dbline -2
L40:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r strg 10 pc
	.dbsym r location 12 I
	.dbend
	.dbfunc e BlinkGreen _BlinkGreen fV
;         period -> R10,R11
	.even
_BlinkGreen::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 163
; }
; 
; void BlinkGreen(int period)
; {
	.dbline 164
;  	 GREEN_LED(ON);
	clr R16
	xcall _GREEN_LED
	.dbline 165
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 166
; 	 GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 167
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L44:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e BlinkRed _BlinkRed fV
;         period -> R10,R11
	.even
_BlinkRed::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 171
; }
; 
; void BlinkRed(int period)
; {
	.dbline 172
;  	 RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 173
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 174
; 	 RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 175
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L45:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e PrintHex _PrintHex fV
;         inbyte -> R10
	.even
_PrintHex::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 179
; }
; 
; void PrintHex(unsigned char inbyte)
; {
	.dbline 181
;      //printf("%2x",inbyte);
;  	 bytetohex(inbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 182
; 	 puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inbyte 10 c
	.dbend
	.dbfunc e PrintWordHex _PrintWordHex fV
;         inword -> R10,R11
	.even
_PrintWordHex::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 186
; }
; 
; void PrintWordHex(unsigned int inword)
; {
	.dbline 188
;  	 //printf("%4x",inword);
;  	 addresstohex(inword);
	movw R16,R10
	xcall _addresstohex
	.dbline 189
; 	 puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline -2
L47:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r inword 10 i
	.dbend
	.dbfunc e EEPROMSetup _EEPROMSetup fV
	.even
_EEPROMSetup::
	.dbline -1
	.dbline 194
; }
; 
; //  TBD
; void EEPROMSetup(void)
; {
	.dbline -2
L48:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReadAVRFlash _ReadAVRFlash fc
;          rbyte -> R10
;      flashbyte -> R10
;        address -> <dead>
	.even
_ReadAVRFlash::
	st -y,r17
	st -y,r16
	st -y,R10
	.dbline -1
	.dbline 200
;  	
; }
; 
; //  Access contents of AVR flash at specified address
; unsigned char ReadAVRFlash(int address)
; {
	.dbline 203
;  	unsigned char flashbyte,rbyte;
; 	
; 	flashbyte = 0;
	clr R10
	.dbline 204
;  	asm("mov r30,r16 \n"
	mov r30,r16 
	mov r31,r17 
	lpm r0,Z 
	mov R10,r0 
	
	.dbline 208
;        "mov r31,r17 \n"
; 	   "lpm r0,Z \n"
; 	   "mov %flashbyte,r0 \n"); 
; 	rbyte = flashbyte;  
	.dbline 209
; 	return(rbyte);                              
	mov R16,R10
	.dbline -2
L49:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,2
	ret
	.dbsym r rbyte 10 c
	.dbsym r flashbyte 10 c
	.dbsym l address 1 I
	.dbend
	.dbfunc e signon _signon fV
	.even
_signon::
	.dbline -1
	.dbline 214
; }
; 
; //  Output sign on message loaded from Flash
; void signon()
; {
	.dbline 215
; 	putfs(signon1);
	ldi R16,<_signon1
	ldi R17,>_signon1
	xcall _putfs
	.dbline 216
; 	putfs(signon2);
	ldi R16,<_signon2
	ldi R17,>_signon2
	xcall _putfs
	.dbline 217
; 	CheckFlashTypes();
	xcall _CheckFlashTypes
	.dbline 218
; 	printf("Device id: %s\n\r",deviceidtext);
	ldi R18,<_deviceidtext
	ldi R19,>_deviceidtext
	ldi R16,<L51
	ldi R17,>L51
	xcall _printf
	.dbline 219
; 	putfs(signon3);
	ldi R16,<_signon3
	ldi R17,>_signon3
	xcall _putfs
	.dbline 220
; 	putfs(signon4);
	ldi R16,<_signon4
	ldi R17,>_signon4
	xcall _putfs
	.dbline 221
; 	putfs(signon5);
	ldi R16,<_signon5
	ldi R17,>_signon5
	xcall _putfs
	.dbline 222
; 	putfs(signon6);
	ldi R16,<_signon6
	ldi R17,>_signon6
	xcall _putfs
	.dbline 223
; 	putfs(signon62);
	ldi R16,<_signon62
	ldi R17,>_signon62
	xcall _putfs
	.dbline 224
; 	putfs(signon65);
	ldi R16,<_signon65
	ldi R17,>_signon65
	xcall _putfs
	.dbline 225
; 	putfs(signon66);
	ldi R16,<_signon66
	ldi R17,>_signon66
	xcall _putfs
	.dbline 226
; 	putfs(signon67);
	ldi R16,<_signon67
	ldi R17,>_signon67
	xcall _putfs
	.dbline 227
; 	putfs(signon7);
	ldi R16,<_signon7
	ldi R17,>_signon7
	xcall _putfs
	.dbline 228
; 	putfs(signon8);
	ldi R16,<_signon8
	ldi R17,>_signon8
	xcall _putfs
	.dbline 229
; 	putfs(signon83);
	ldi R16,<_signon83
	ldi R17,>_signon83
	xcall _putfs
	.dbline 230
; 	putfs(signon85);
	ldi R16,<_signon85
	ldi R17,>_signon85
	xcall _putfs
	.dbline 231
; 	putfs(signon9);
	ldi R16,<_signon9
	ldi R17,>_signon9
	xcall _putfs
	.dbline 232
; 	putfs(signon10);
	ldi R16,<_signon10
	ldi R17,>_signon10
	xcall _putfs
	.dbline -2
L50:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayEEPROM _DisplayEEPROM fV
;       numlines -> y+5
; bytesonlastline -> y+4
;        linecnt -> y+2
;      tempvalue -> R20
;       asciicnt -> y+1
;     newaddress -> R12,R13
;       crcvalue -> y+0
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+17
	.even
_DisplayEEPROM::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,7
	.dbline -1
	.dbline 238
; }
; 
; 
; //  Display AVR EEPROM memory
; void DisplayEEPROM(int address,int numbytes)
; {
	.dbline 242
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+1,R0
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	.dbline 243
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 244
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+6,R17
	std y+5,R16
	.dbline 245
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R10
	sub R2,R16
	sbc R3,R17
	std y+4,R2
	xjmp L54
L53:
	.dbline 246
; 	 while(linecnt<numlines) {
	.dbline 247
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 248
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 249
; 		 PrintHex(bytesonline);		 //  Output bytes on line
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 250
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 252
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 253
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 254
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 255
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 256
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 257
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 259
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L56
	ldi R17,>L56
	xcall _puts
	.dbline 261
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L60
L57:
	.dbline 261
	.dbline 262
; 	         byte = EEPROM_read(i+newaddress);
	mov R16,R10
	clr R17
	add R16,R12
	adc R17,R13
	xcall _EEPROM_read
	mov R22,R16
	.dbline 263
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+1
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 264
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 265
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 266
; 	         }
L58:
	.dbline 261
	inc R10
L60:
	.dbline 261
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L57
X11:
	.dbline 267
; 		 linecnt++;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 268
; 		 asciicnt = 0;
	clr R0
	std y+1,R0
	.dbline 270
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 271
; 	     puts("  ");
	ldi R16,<L61
	ldi R17,>L61
	xcall _puts
	.dbline 272
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L65
L62:
	.dbline 272
	.dbline 273
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L66
X12:
	mov R24,R14
	cpi R24,128
	brsh L66
X13:
	.dbline 273
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L67
L66:
	.dbline 274
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L67:
	.dbline 275
; 			 }
L63:
	.dbline 272
	inc R10
L65:
	.dbline 272
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L62
X14:
	.dbline 276
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 277
; 		 }
L54:
	.dbline 246
	ldd R0,y+2
	ldd R1,y+3
	ldd R16,y+5
	ldd R17,y+6
	cp R0,R16
	cpc R1,R17
	brge X21
	xjmp L53
X21:
X15:
	.dbline 278
; 	 if(bytesonlastline) {
	ldd R0,y+4
	tst R0
	brne X22
	xjmp L68
X22:
X16:
	.dbline 278
	.dbline 279
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 280
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 282
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	ldd R16,y+4
	xcall _PrintHex
	.dbline 283
; 		 crcvalue += bytesonlastline;
	ldd R0,y+0
	ldd R16,y+4
	add R0,R16
	std y+0,R0
	.dbline 285
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 286
; 	     addresstohex(newaddress);
	movw R16,R12
	xcall _addresstohex
	.dbline 287
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 288
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 289
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 290
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 291
; 	     puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline 293
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L56
	ldi R17,>L56
	xcall _puts
	.dbline 295
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L73
L70:
	.dbline 295
	.dbline 296
; 	         byte = EEPROM_read(i+address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	ldd R0,y+17
	ldd R1,y+18
	add R16,R0
	adc R17,R1
	add R16,R2
	adc R17,R3
	xcall _EEPROM_read
	mov R20,R16
	mov R22,R20
	.dbline 297
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+1
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 298
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 299
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 300
; 	         }
L71:
	.dbline 295
	inc R10
L73:
	.dbline 295
	ldd R0,y+4
	cp R10,R0
	brlo L70
X17:
	.dbline 302
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 303
; 	     puts("  ");
	ldi R16,<L61
	ldi R17,>L61
	xcall _puts
	.dbline 304
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L77
L74:
	.dbline 304
	.dbline 305
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L78
X18:
	cpi R20,128
	brsh L78
X19:
	.dbline 305
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L79
L78:
	.dbline 306
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L79:
	.dbline 307
; 			 }
L75:
	.dbline 304
	inc R10
L77:
	.dbline 304
	ldd R0,y+4
	cp R10,R0
	brlo L74
X20:
	.dbline 308
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 309
; 		 }
L68:
	.dbline -2
L52:
	.dbline 0 ; func end
	adiw R28,7
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 5 I
	.dbsym l bytesonlastline 4 c
	.dbsym l linecnt 2 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 1 c
	.dbsym r newaddress 12 I
	.dbsym l crcvalue 0 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 17 I
	.dbend
	.dbfunc e DisplayAVRFlash _DisplayAVRFlash fV
;       numlines -> y+3
; bytesonlastline -> R12
;     newaddress -> R20,R21
;      tempvalue -> R10
;       asciicnt -> y+2
;        linecnt -> y+0
;       crcvalue -> R14
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+15
	.even
_DisplayAVRFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,5
	.dbline -1
	.dbline 314
; }
; 
; //  Display P1 AVR Flash memory
; void DisplayAVRFlash(int address,int numbytes)
; {
	.dbline 318
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+2,R0
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 319
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 320
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+4,R17
	std y+3,R16
	.dbline 321
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	mov R12,R10
	sub R12,R16
	sbc R13,R17
	xjmp L82
L81:
	.dbline 322
; 	 while(linecnt<numlines) {
	.dbline 323
; 	 	 crcvalue = 0;
	clr R14
	.dbline 324
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 326
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 327
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R14
	clr R5
	add R4,R2
	adc R5,R3
	mov R14,R4
	.dbline 329
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	ldd R20,y+15
	ldd R21,y+16
	add R20,R16
	adc R21,R17
	.dbline 330
; 	     PrintWordHex(newaddress);
	movw R16,R20
	xcall _PrintWordHex
	.dbline 331
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R24,R20
	andi R24,0
	movw R10,R24
	mov R10,R11
	clr R11
	.dbline 332
; 		 crcvalue += tempvalue;
	add R14,R10
	.dbline 333
; 		 tempvalue = newaddress&0x00ff;
	movw R24,R20
	andi R25,0
	.dbline 334
; 		 crcvalue += tempvalue;
	add R14,R24
	.dbline 336
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L56
	ldi R17,>L56
	xcall _puts
	.dbline 338
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L87
L84:
	.dbline 338
	.dbline 339
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R22,R16
	.dbline 340
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+2
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 341
; 			 crcvalue += byte;
	add R14,R16
	.dbline 342
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 343
; 	         }
L85:
	.dbline 338
	inc R10
L87:
	.dbline 338
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L84
X23:
	.dbline 344
; 		 linecnt++;
	ldd R24,y+0
	ldd R25,y+1
	adiw R24,1
	std y+1,R25
	std y+0,R24
	.dbline 345
; 		 asciicnt = 0;
	clr R0
	std y+2,R0
	.dbline 347
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 348
; 	     puts("  ");
	ldi R16,<L61
	ldi R17,>L61
	xcall _puts
	.dbline 349
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L91
L88:
	.dbline 349
	.dbline 350
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L92
X24:
	cpi R20,128
	brsh L92
X25:
	.dbline 350
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L93
L92:
	.dbline 351
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L93:
	.dbline 352
; 			 }
L89:
	.dbline 349
	inc R10
L91:
	.dbline 349
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L88
X26:
	.dbline 353
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 354
; 		 }
L82:
	.dbline 322
	ldd R0,y+0
	ldd R1,y+1
	ldd R16,y+3
	ldd R17,y+4
	cp R0,R16
	cpc R1,R17
	brge X33
	xjmp L81
X33:
X27:
	.dbline 355
; 	 if(bytesonlastline) {
	tst R12
	brne X34
	xjmp L94
X34:
X28:
	.dbline 355
	.dbline 356
; 	     crcvalue = 0;
	clr R14
	.dbline 357
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 359
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	mov R16,R12
	xcall _PrintHex
	.dbline 361
; 	     //  Output hex start address
; 	     PrintWordHex(address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	ldd R16,y+15
	ldd R17,y+16
	add R16,R2
	adc R17,R3
	xcall _PrintWordHex
	.dbline 363
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L56
	ldi R17,>L56
	xcall _puts
	.dbline 365
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L99
L96:
	.dbline 365
	.dbline 366
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R20,R16
	mov R22,R20
	.dbline 367
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+2
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 368
; 			 crcvalue += byte;
	add R14,R16
	.dbline 369
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 370
; 	         }
L97:
	.dbline 365
	inc R10
L99:
	.dbline 365
	cp R10,R12
	brlo L96
X29:
	.dbline 372
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 373
; 	     puts("  ");
	ldi R16,<L61
	ldi R17,>L61
	xcall _puts
	.dbline 374
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L103
L100:
	.dbline 374
	.dbline 375
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L104
X30:
	cpi R20,128
	brsh L104
X31:
	.dbline 375
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L105
L104:
	.dbline 376
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L105:
	.dbline 377
; 			 }
L101:
	.dbline 374
	inc R10
L103:
	.dbline 374
	cp R10,R12
	brlo L100
X32:
	.dbline 378
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 379
; 		 }
L94:
	.dbline -2
L80:
	.dbline 0 ; func end
	adiw R28,5
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 3 I
	.dbsym r bytesonlastline 12 c
	.dbsym r newaddress 20 I
	.dbsym r tempvalue 10 c
	.dbsym l asciicnt 2 c
	.dbsym l linecnt 0 I
	.dbsym r crcvalue 14 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 15 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 383
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 384
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L109
X35:
	ldi R22,1
	ldi R23,0
	xjmp L110
L109:
	clr R22
	clr R23
L110:
	ldi R24,70
	cp R24,R16
	brlo L111
X36:
	ldi R20,1
	ldi R21,0
	xjmp L112
L111:
	clr R20
	clr R21
L112:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X37
	tst R3
	breq L107
X37:
	.dbline 384
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L106
L107:
	.dbline 385
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L115
X38:
	ldi R22,1
	ldi R23,0
	xjmp L116
L115:
	clr R22
	clr R23
L116:
	ldi R24,102
	cp R24,R16
	brlo L117
X39:
	ldi R20,1
	ldi R21,0
	xjmp L118
L117:
	clr R20
	clr R21
L118:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X40
	tst R3
	breq L113
X40:
	.dbline 385
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L106
L113:
	.dbline 386
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L106:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e ScanHex _ScanHex fi
;        address -> R10,R11
;            len -> R12
;              i -> R20
	.even
_ScanHex::
	xcall push_xgsetF0FC
	.dbline -1
	.dbline 392
; }
; 
; // Read in a hex string and convert to int or long
; //  TBD - add long support for serial flash support
; unsigned int  ScanHex()
; {
	.dbline 394
;  	 unsigned int  address;
;  	 char i=0,len;
	clr R20
	.dbline 396
; 	 
; 	 address = 0;
	clr R10
	clr R11
	.dbline 397
; 	 putcharr((instrg[0]=getcharr()));
	xcall _getcharr
	sts _instrg,R16
	xcall _putcharr
	xjmp L121
L120:
	.dbline 398
;  	 while((instrg[i]!=CR)&&(instrg[i]!=' ')) {
	.dbline 399
; 	 	 i++;
	inc R20
	.dbline 400
; 	     putcharr((instrg[i]=getcharr()));
	xcall _getcharr
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	xcall _putcharr
	.dbline 401
; 		 }
L121:
	.dbline 398
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R22,z+0
	clr R23
	cpi R22,13
	breq L123
X41:
	cpi R22,32
	brne L120
X42:
L123:
	.dbline 402
; 	 instrg[i] = 0;
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 403
; 	 len = strlen(instrg);
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _strlen
	movw R12,R16
	.dbline 404
; 	 address = hextobyte(instrg[len-1]);
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R10,R14
	clr R11
	.dbline 405
; 	 i = 1;
	ldi R20,1
	xjmp L126
L125:
	.dbline 406
; 	 while(i<len) {
	.dbline 407
; 	     if(i==1) address += (hextobyte(instrg[len-i-1])*16);
	cpi R20,1
	brne L128
X43:
	.dbline 407
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	ldi R24,16
	mul R24,R14
	add R10,R0
	adc R11,R1
L128:
	.dbline 408
; 	     if(i==2) address += (hextobyte(instrg[len-i-1])*256);
	cpi R20,2
	brne L131
X44:
	.dbline 408
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	add R10,R16
	adc R11,R17
L131:
	.dbline 409
; 	     if(i==3) address += (hextobyte(instrg[len-i-1])*4096);
	cpi R20,3
	brne L134
X45:
	.dbline 409
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,4096
	ldi R17,16
	xcall empy16s
	add R10,R16
	adc R11,R17
L134:
	.dbline 410
; 		 i++;
	inc R20
	.dbline 411
; 		 }
L126:
	.dbline 406
	cp R20,R12
	brsh X47
	xjmp L125
X47:
X46:
	.dbline 412
; 	 return address;
	movw R16,R10
	.dbline -2
L119:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
	.dbsym r address 10 i
	.dbsym r len 12 c
	.dbsym r i 20 c
	.dbend
	.dbfunc e GetByteHex _GetByteHex fc
;           strg -> y+0
	.even
_GetByteHex::
	st -y,R10
	sbiw R28,3
	.dbline -1
	.dbline 416
; }
; 
; unsigned char GetByteHex()
; {
	.dbline 421
;  	 char strg[3];
; 	 
; //	 putcharr((strg[0]=getchar()));
; //	 putcharr((strg[1]=getchar()));
; 	 strg[0]=getcharr();
	xcall _getcharr
	std y+0,R16
	.dbline 422
; 	 strg[1]=getcharr();
	xcall _getcharr
	std y+1,R16
	.dbline 423
; 	 strg[2] = 0;
	clr R2
	std y+2,R2
	.dbline 424
; 	 return converttohex(strg);
	movw R16,R28
	xcall _converttohex
	mov R10,R16
	.dbline -2
L137:
	.dbline 0 ; func end
	adiw R28,3
	ld R10,y+
	ret
	.dbsym l strg 0 A[3:3]c
	.dbend
	.dbfunc e DisplayMemory _DisplayMemory fV
;         length -> R12,R13
;        address -> R10,R11
;         inchar -> R14
	.even
_DisplayMemory::
	xcall push_xgset30FC
	sbiw R28,1
	.dbline -1
	.dbline 428
; }
; 
; void DisplayMemory(void)
; {
	.dbline 432
;     unsigned char inchar;
; 	unsigned int address, length;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R14,R16
	.dbline 433
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 434
; 	putCRLF();
	xcall _putCRLF
	.dbline 435
; 	putfs(displaymessage1);
	ldi R16,<_displaymessage1
	ldi R17,>_displaymessage1
	xcall _putfs
	.dbline 436
; 	address = ScanHex();
	xcall _ScanHex
	movw R10,R16
	.dbline 437
; 	length = ScanHex();
	xcall _ScanHex
	movw R12,R16
	.dbline 438
; 	putCRLF();
	xcall _putCRLF
	.dbline 439
; 	switch (inchar) {
	mov R20,R14
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L145
X48:
	cpi R20,66
	ldi R30,0
	cpc R21,R30
	breq L147
X49:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L144
X50:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L146
X51:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L141
X52:
L148:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L145
X53:
	cpi R20,98
	ldi R30,0
	cpc R21,R30
	breq L147
X54:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L144
X55:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L146
X56:
	xjmp L141
L144:
	.dbline 441
; 	    case 'e': case 'E':
; 			DisplayEEPROM(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayEEPROM
	.dbline 442
; 		    break;
	xjmp L142
L145:
	.dbline 444
; 		case 'a': case 'A':
; 		    DisplayAVRFlash(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayAVRFlash
	.dbline 445
; 		    break;
	xjmp L142
L146:
	.dbline 451
; 		//  In order to access Blackfin Flash the AVR must ask the Blackfin
; 		//  to release control of the SPI lines.  This is simulated in Rev A
; 		//  boards by resetting the Blackfin (which should release the SPI lines)
; 		//  On completion the AVR SPI lines are released.
; 		case 'f': case 'F':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 452
; 		    DisplaySerialFlash(address,length,READCONTINUOUS);	
	ldi R24,1
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 453
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 454
; 		    break;
	xjmp L142
L147:
	.dbline 456
; 		case 'b': case 'B':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 457
; 		    DisplaySerialFlash(address,length,READBUFFER);			
	ldi R24,2
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 458
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 459
; 		    break;
	xjmp L142
L141:
	.dbline 461
; 		default:
; 		    putfs(displaymessage33);
	ldi R16,<_displaymessage33
	ldi R17,>_displaymessage33
	xcall _putfs
	.dbline 462
; 		    break;
L142:
	.dbline -2
L140:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r length 12 i
	.dbsym r address 10 i
	.dbsym r inchar 14 c
	.dbend
	.dbfunc e checkcrc _checkcrc fI
;        cycbyte -> <dead>
	.even
_checkcrc::
	st -y,r17
	st -y,r16
	.dbline -1
	.dbline 469
; 	    }
; }
; 
; 
; // Check intelbinary CRC 
; int checkcrc(unsigned char cycbyte)
; {
	.dbline 470
; 	GetByteHex();
	xcall _GetByteHex
	.dbline 471
;  	return 1;
	ldi R16,1
	ldi R17,0
	.dbline -2
L149:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l cycbyte 0 c
	.dbend
	.dbfunc e DecodeIntelHex _DecodeIntelHex fI
;    addressbyte -> <dead>
;           strg -> y+0
;         inbyte -> R10
;              i -> R20,R21
	.even
_DecodeIntelHex::
	xcall push_xgset303C
	sbiw R28,8
	.dbline -1
	.dbline 486
; }
; 
; // Convert Intel Hex ASCII string to binary
; //
; // :10 0100 00 0C948F0D0C941D0E0C941D0E0C941D0E 38
; // :1001000000C941D0E0C941D0E0C944E590C941D0E38
; // This routine decodes a line of Intel Hex.  Other 
; // routines write the data to either AVR Flash, external Flash
; // or AVR EEPROM
; //
; //   :02 0000 04 0000FA  - IntelHex32 super address record
; // 
; //  TBD - check crc byte - drop record if incorrect
; int DecodeIntelHex(void)
; {
	.dbline 490
;  	 unsigned char strg[8],addressbyte,inbyte;
; 	 int i;
; 	 
; 	 putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 492
; 	 // Convert count of bytes on line
; 	 bytesonline = GetByteHex();
	xcall _GetByteHex
	mov R2,R16
	clr R3
	sts _bytesonline+1,R3
	sts _bytesonline,R2
	.dbline 496
; 	 
; 	 // Convert address to binary - ignore filler byte
; 	 // Typical Intel Hex consists of 4 ASCII characters
; 	 inteladdress = GetByteHex()*256;
	xcall _GetByteHex
	mov R18,R16
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	sts _inteladdress+2+1,R5
	sts _inteladdress+2,R4
	.dbline 497
; 	 inteladdress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	clr R4
	clr R5
	lds R8,_inteladdress+2
	lds R9,_inteladdress+2+1
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	sts _inteladdress+1,R7
	sts _inteladdress,R6
	sts _inteladdress+2+1,R9
	sts _inteladdress+2,R8
	.dbline 500
; 	 
; 	 // Read dump byte (2 characters)
; 	 intelrecordcommand = GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	sts _intelrecordcommand,R12
	.dbline 502
; 	 
; 	 if(intelrecordcommand==0x04) {
	cpi R16,4
	brne L151
X57:
	.dbline 502
	.dbline 503
; 	     intelsuperaddress = GetByteHex()*256;
	xcall _GetByteHex
	mov R12,R16
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _intelsuperaddress+1,R17
	sts _intelsuperaddress,R16
	.dbline 504
; 		 intelsuperaddress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_intelsuperaddress
	lds R5,_intelsuperaddress+1
	add R4,R2
	adc R5,R3
	sts _intelsuperaddress+1,R5
	sts _intelsuperaddress,R4
	.dbline 505
; 		 }
	xjmp L152
L151:
	.dbline 506
; 	 else  {
	.dbline 508
; 	     // Convert all data to binary
; 	     for(i=0; i<bytesonline; i++) {
	clr R20
	clr R21
	xjmp L156
L153:
	.dbline 508
	.dbline 509
; 		     inbyte = GetByteHex(strg);
	movw R16,R28
	xcall _GetByteHex
	mov R12,R16
	mov R10,R12
	.dbline 510
; 		     intelbinary[i] = inbyte;
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	movw R30,R20
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 511
; 	 	     }
L154:
	.dbline 508
	subi R20,255  ; offset = 1
	sbci R21,255
L156:
	.dbline 508
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	cp R20,R2
	cpc R21,R3
	brlo L153
X58:
	.dbline 512
; 		 }
L152:
	.dbline 515
; 		 
; 	// Check CRC - todo
; 	if(checkcrc(inbyte)) return 1;
	mov R16,R10
	xcall _checkcrc
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L157
X59:
	.dbline 515
	ldi R16,1
	ldi R17,0
	xjmp L150
L157:
	.dbline 516
; 	else return -1;
	ldi R16,-1
	ldi R17,-1
	.dbline -2
L150:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgset303C
	.dbsym l addressbyte 1 c
	.dbsym l strg 0 A[8:8]c
	.dbsym r inbyte 10 c
	.dbsym r i 20 I
	.dbend
	.dbfunc e ProgramEEPROM _ProgramEEPROM fV
;              i -> R10
	.even
_ProgramEEPROM::
	st -y,R10
	.dbline -1
	.dbline 521
; }
; 
; //  Write decoded Intel hex to EEPROM
; void ProgramEEPROM(void)
; {
	.dbline 524
;      unsigned char i;
; 	 
; 	 for(i=0; i<bytesonline; i++)  EEPROMWrite(inteladdress+i,intelbinary[i]);
	clr R10
	xjmp L163
L160:
	.dbline 524
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R2,R10
	clr R3
	clr R4
	clr R5
	lds R8,_inteladdress+2
	lds R9,_inteladdress+2+1
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R16,R6
	xcall _EEPROMWrite
L161:
	.dbline 524
	inc R10
L163:
	.dbline 524
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L160
X60:
	.dbline -2
L159:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r i 10 c
	.dbend
	.dbfunc e ProgramAVRFlash _ProgramAVRFlash fV
;         inchar -> R10
	.even
_ProgramAVRFlash::
	st -y,R10
	.dbline -1
	.dbline 529
; }
; 
; //  TBD - AVR Flash hold program so programming AVR flash may overwrite program
; void ProgramAVRFlash(void)
; {
	xjmp L166
L165:
	.dbline 532
;  	 char inchar;
; 	 
;  	 while((inchar=getcharr())!=CR) putcharr(inchar);
	mov R16,R10
	xcall _putcharr
L166:
	.dbline 532
	xcall _getcharr
	mov R10,R16
	cpi R16,13
	brne L165
X61:
	.dbline 533
; 	 printf("\n-");
	ldi R16,<L168
	ldi R17,>L168
	xcall _printf
	.dbline -2
L164:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e CleanUpFlashState _CleanUpFlashState fV
	.even
_CleanUpFlashState::
	.dbline -1
	.dbline 537
; }
; 
; void CleanUpFlashState()
; {
	.dbline 538
; 	if(flashdatainbuffer==YES)  {
	lds R24,_flashdatainbuffer
	cpi R24,1
	brne L170
X62:
	.dbline 538
	.dbline 539
; 	    inteladdress = oldinteladdress;  // end of file record destroyed intelad
	lds R4,_oldinteladdress+2
	lds R5,_oldinteladdress+2+1
	lds R2,_oldinteladdress
	lds R3,_oldinteladdress+1
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	sts _inteladdress+2+1,R5
	sts _inteladdress+2,R4
	.dbline 540
; 	    ProgramBuffertoPageErase(1);
	ldi R16,1
	xcall _ProgramBuffertoPageErase
	.dbline 541
; 		WaitForFlashFree();
	xcall _WaitForFlashFree
	.dbline 542
; 		}
L170:
	.dbline 543
; 	if(flashprogrammingactive==YES)  {
	lds R24,_flashprogrammingactive
	cpi R24,1
	brne L172
X63:
	.dbline 543
	.dbline 544
; 		Release_SPI();
	xcall _Release_SPI
	.dbline 545
; 		flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 546
; 		flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 547
; 		flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 548
; 		flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 549
; 		}
L172:
	.dbline -2
L169:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramMemory _ProgramMemory fV
	.even
_ProgramMemory::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 561
; }
; 
; //  Main memory programming selection function
; //  Program EEPROM, AVR Flash or SPI Flash.
; //  Three IntelHex32 Records 0x00, 0x01 and 0x04 are processed by this
; //  routine.  0x00 is a data record, 0x01 is End of File record and 
; //  0x04 is extended address record
; //
; //  TBD - no intel record time out - reset defaults if not intel 
; //        records received after 3 seconds
; void ProgramMemory(void)
; {
	.dbline 562
;  	DecodeIntelHex();
	xcall _DecodeIntelHex
	.dbline 563
; 	switch (programmode) {
	lds R20,_programmode
	clr R21
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L181
X64:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L178
X65:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L184
X66:
	xjmp L175
L178:
	.dbline 565
; 	    case LEEPROM:
; 			if(intelrecordcommand==0) ProgramEEPROM();
	lds R2,_intelrecordcommand
	tst R2
	brne L176
X67:
	.dbline 565
	xcall _ProgramEEPROM
	.dbline 566
; 			break;
	xjmp L176
L181:
	.dbline 568
; 		case LAVRFLASH:
; 		    if(intelrecordcommand==0) ProgramAVRFlash();
	lds R2,_intelrecordcommand
	tst R2
	brne L176
X68:
	.dbline 568
	xcall _ProgramAVRFlash
	.dbline 569
; 			break;
	xjmp L176
L184:
	.dbline 582
; 			
; 		//  To access Blackfin Flash the Blackfin must not have control 
; 		//  of the shared SPI lines and the Blackfin reset line must not
; 		//  be active.  The Blackfin releases control of the SPI lines under 
; 		//  software control or by being forced to boot mode 0.  If the Blackfin
; 		//  is reset to boot mode 3 it will attempt to load a program from 
; 		//  serial flash preventing the AVR from accessing the serial flash.
; 		
; 		//  This implementation forces the Blackfin to reboot.
; 		//  Cooperative flash access still TBD
; 		case LFLASH:
; 		    // Data record			
; 			if(intelrecordcommand==0) {
	lds R2,_intelrecordcommand
	tst R2
	brne L185
X69:
	.dbline 582
	.dbline 583
; 			    flashcountdown = 3000;  // 3 second no new Hex record timeout
	ldi R24,3000
	ldi R25,11
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
	.dbline 585
; 			    //  See is SPI Master is active - set active if not
; 			    if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L187
X70:
	.dbline 585
	.dbline 586
; 				    Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 587
; 					}
L187:
	.dbline 589
; 					
; 		        ProgramSerialFlash();		
	xcall _ProgramSerialFlash
	.dbline 590
; 				}
	xjmp L176
L185:
	.dbline 592
; 			// Extended address record
; 			else if(intelrecordcommand==0x04) ; // nothing to do
	lds R24,_intelrecordcommand
	cpi R24,4
	brne L189
X71:
	.dbline 592
	xjmp L176
L189:
	.dbline 595
; 			
; 			// End of File record - reset all variables
; 			else if(intelrecordcommand==0x01) CleanUpFlashState();
	lds R24,_intelrecordcommand
	cpi R24,1
	brne L176
X72:
	.dbline 595
	xcall _CleanUpFlashState
	.dbline 596
; 			break;
L175:
L176:
	.dbline -2
L174:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbend
	.dbfunc e LoadMemory _LoadMemory fV
;         inchar -> R10
	.even
_LoadMemory::
	xcall push_xgset300C
	.dbline -1
	.dbline 603
; 		} 
; }
; 
; //  Set default memory programming mode
; //  Subsequent Intel Hex dumps will load to the specific memory
; void LoadMemory(void)
; {
	.dbline 606
;     unsigned char inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R10,R16
	.dbline 607
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 608
; 	switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L199
X73:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L197
X74:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L198
X75:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L195
X76:
L200:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L199
X77:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L197
X78:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L198
X79:
	xjmp L195
L197:
	.dbline 610
; 	    case 'e': case 'E':
; 			programmode = LEEPROM;
	ldi R24,101
	sts _programmode,R24
	.dbline 611
; 			putfs(loadmessage1);
	ldi R16,<_loadmessage1
	ldi R17,>_loadmessage1
	xcall _putfs
	.dbline 612
; 		    break;
	xjmp L195
L198:
	.dbline 614
; 		case 'f': case 'F':
; 			programmode = LFLASH;
	ldi R24,102
	sts _programmode,R24
	.dbline 615
; 			putfs(loadmessage2);
	ldi R16,<_loadmessage2
	ldi R17,>_loadmessage2
	xcall _putfs
	.dbline 616
; 		    break;
	xjmp L195
L199:
	.dbline 618
; 		case 'a': case 'A':
; 			programmode = LAVRFLASH;
	ldi R24,97
	sts _programmode,R24
	.dbline 619
; 		    putfs(loadmessage3);
	ldi R16,<_loadmessage3
	ldi R17,>_loadmessage3
	xcall _putfs
	.dbline 620
; 		    break;
	.dbline 622
; 		default:
; 		   break;
L195:
	.dbline -2
L193:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.area lit(rom, con, rel)
L202:
	.byte 48,46,57,52,0
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
	.dbfunc e ProgramVersion _ProgramVersion fV
;        version -> y+0
	.even
_ProgramVersion::
	sbiw R28,5
	.dbline -1
	.dbline 629
; 	    }
; }
; 
; //  Output program version
; //   TBD - read from EEPROM
; void ProgramVersion(void)
; {
	.dbline 630
;       char version[5]="0.94";
	ldi R24,<L202
	ldi R25,>L202
	movw R30,R28
	ldi R16,5
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 632
; 	  
; 	  putfs(progmessage);
	ldi R16,<_progmessage
	ldi R17,>_progmessage
	xcall _putfs
	.dbline 633
; 	  puts(version);
	movw R16,R28
	xcall _puts
	.dbline 634
; 	  putCRLF();
	xcall _putCRLF
	.dbline -2
L201:
	.dbline 0 ; func end
	adiw R28,5
	ret
	.dbsym l version 0 A[5:5]c
	.dbend
	.dbfunc e AnalogCh _AnalogCh fI
;           high -> R12
;            low -> R10
;           mode -> R20
;             ch -> R22,R23
	.even
_AnalogCh::
	xcall push_xgsetF03C
	mov R20,R18
	movw R22,R16
	.dbline -1
	.dbline 640
; }
; 
; //  Read selected analog channel - wait until it completes
; //   TBD - background interrupt process
; int AnalogCh(int ch,char mode)
; {
	.dbline 643
;  	unsigned char low,high;
; 	
; 	if(ch==0) ADMUX = 0x00;  // Select AVCC, ch 0
	cpi R22,0
	cpc R22,R23
	brne L204
X80:
	.dbline 643
	clr R2
	sts 124,R2
	xjmp L205
L204:
	.dbline 644
; 	else if(ch==1) ADMUX = 0x01; // 
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brne L206
X81:
	.dbline 644
	ldi R24,1
	sts 124,R24
	xjmp L207
L206:
	.dbline 645
; 	else if(ch==2) ADMUX = 0x02;
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	brne L208
X82:
	.dbline 645
	ldi R24,2
	sts 124,R24
	xjmp L209
L208:
	.dbline 646
; 	else if(ch==3) ADMUX = 0x03;
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	brne L210
X83:
	.dbline 646
	ldi R24,3
	sts 124,R24
	xjmp L211
L210:
	.dbline 647
; 	else if(ch==4) ADMUX = 0x04; 
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	brne L212
X84:
	.dbline 647
	ldi R24,4
	sts 124,R24
	xjmp L213
L212:
	.dbline 648
; 	else if(ch==5) ADMUX = 0x05;
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	brne L214
X85:
	.dbline 648
	ldi R24,5
	sts 124,R24
	xjmp L215
L214:
	.dbline 649
; 	else if(ch==6) ADMUX = 0x06;
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	brne L216
X86:
	.dbline 649
	ldi R24,6
	sts 124,R24
	xjmp L217
L216:
	.dbline 650
; 	else if(ch==7) ADMUX = 0x07;
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne L218
X87:
	.dbline 650
	ldi R24,7
	sts 124,R24
	xjmp L219
L218:
	.dbline 651
; 	else if(ch==8) ADMUX = 0x0C;  // Boost ADC2 gain by 10x
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	brne L220
X88:
	.dbline 651
	ldi R24,12
	sts 124,R24
L220:
L219:
L217:
L215:
L213:
L211:
L209:
L207:
L205:
	.dbline 652
; 	if(mode==INTERNALREF)  ADMUX |= (1<<REFS1)||(1<<REFS0);
	cpi R20,105
	brne L222
X89:
	.dbline 652
	lds R24,124
	ori R24,1
	sts 124,R24
	xjmp L223
L222:
	.dbline 653
; 	else ADMUX |= (1<<REFS0);  // use AVCC
	lds R24,124
	ori R24,64
	sts 124,R24
L223:
	.dbline 655
; 	
; 	ADCSRA = (1<<ADEN)|(1<<ADSC); // Enable ADC, start conversion, max clock
	ldi R24,192
	sts 122,R24
L224:
	.dbline 656
; 	while(!(ADCSRA&(1<<ADIF))) ; // loop until conversion completes
L225:
	.dbline 656
	lds R2,122
	sbrs R2,4
	rjmp L224
X90:
	.dbline 657
; 	shortdelay(10);
	ldi R16,10
	ldi R17,0
	xcall _shortdelay
	.dbline 659
; 	
; 	low = ADCL;
	lds R10,120
	.dbline 660
; 	high = ADCH;
	lds R12,121
	.dbline 661
; 	return (low + (high*256));
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L203:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r mode 20 c
	.dbsym r ch 22 I
	.dbend
	.dbfunc e DumpAnalogChs _DumpAnalogChs fV
;    analogvalue -> R10,R11
;              i -> R20,R21
	.even
_DumpAnalogChs::
	xcall push_xgset300C
	.dbline -1
	.dbline 665
; }
; 
; void DumpAnalogChs(void)
; {
	.dbline 668
;     int  i,analogvalue;
; 	
; 	printf("Analog Channels 0..7\n\r");
	ldi R16,<L228
	ldi R17,>L228
	xcall _printf
	.dbline 669
;  	for(i=0; i<8; i++) {
	clr R20
	clr R21
L229:
	.dbline 669
	.dbline 670
; 	    analogvalue = AnalogCh(i,EXTERNALREF);
	ldi R18,101
	movw R16,R20
	xcall _AnalogCh
	movw R10,R16
	.dbline 671
; 		printf("%d ",analogvalue);
	movw R18,R10
	ldi R16,<L233
	ldi R17,>L233
	xcall _printf
	.dbline 672
; 		} 
L230:
	.dbline 669
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 669
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L229
X91:
	.dbline 673
; 	printf("\n\r"); 
	ldi R16,<L234
	ldi R17,>L234
	xcall _printf
	.dbline -2
L227:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r analogvalue 10 I
	.dbsym r i 20 I
	.dbend
	.dbfunc e readint _readint fI
;         intnum -> R20,R21
;         endptr -> R10,R11
;      incharbuf -> y+0
;              i -> R22,R23
;         inchar -> R10
	.even
_readint::
	xcall push_xgsetF03C
	sbiw R28,10
	.dbline -1
	.dbline 678
; }
; 
; // Collect characters until CR, LF or space found
; int readint()
; {
	.dbline 682
;  	char incharbuf[10],inchar;
; 	int  intnum,i,endptr;
; 	
; 	intnum = 0;
	clr R20
	clr R21
	.dbline 683
; 	i = 0;
	clr R22
	clr R23
	xjmp L237
L236:
	.dbline 685
; 	// Skip preceeding white space
; 	while((inchar=getcharr())==' ') putchar(inchar);
	mov R16,R10
	xcall _putchar$device_specific$
L237:
	.dbline 685
	xcall _getcharr
	mov R10,R16
	cpi R16,32
	breq L236
X92:
	.dbline 686
; 	putchar(inchar);
	xcall _putchar$device_specific$
	xjmp L240
L239:
	.dbline 687
; 	while((i<10)&&(inchar!=CR)&&(inchar!=LF)&&(inchar!=' ')) {
	.dbline 688
; 	    incharbuf[i++] = inchar;
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R24,R28
	movw R30,R2
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 689
; 		inchar = getcharr();
	xcall _getcharr
	mov R12,R16
	mov R10,R12
	.dbline 690
; 		putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 691
; 		}
L240:
	.dbline 687
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	brge L244
X93:
	mov R24,R10
	cpi R24,13
	breq L244
X94:
	cpi R24,10
	breq L244
X95:
	cpi R24,32
	brne L239
X96:
L244:
	.dbline 692
; 	incharbuf[i] = 0;
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 693
; 	endptr = strlen(incharbuf) - 1;
	movw R16,R28
	xcall _strlen
	movw R22,R16
	movw R24,R22
	sbiw R24,1
	movw R10,R24
	.dbline 694
; 	if(endptr>=0) intnum = (incharbuf[endptr--] - '0');
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L245
X97:
	.dbline 694
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	subi R20,48
	sbci R21,0
L245:
	.dbline 695
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*10;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L247
X98:
	.dbline 695
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,10
	mul R24,R2
	movw R24,R0
	subi R24,224
	sbci R25,1
	add R20,R24
	adc R21,R25
L247:
	.dbline 696
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*100;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L249
X99:
	.dbline 696
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,100
	mul R24,R2
	movw R24,R0
	subi R24,192
	sbci R25,18
	add R20,R24
	adc R21,R25
L249:
	.dbline 697
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*1000;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L251
X100:
	.dbline 697
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	clr R19
	ldi R16,1000
	ldi R17,3
	xcall empy16s
	movw R24,R16
	subi R24,128
	sbci R25,187
	add R20,R24
	adc R21,R25
L251:
	.dbline 698
; 	if(endptr>=0) intnum = (incharbuf[endptr--] - '0')*10000;	
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L253
X101:
	.dbline 698
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	clr R19
	ldi R16,10000
	ldi R17,39
	xcall empy16s
	movw R20,R16
	subi R20,0
	sbci R21,83
L253:
	.dbline 699
; 	return intnum;
	movw R16,R20
	.dbline -2
L235:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF03C
	.dbsym r intnum 20 I
	.dbsym r endptr 10 I
	.dbsym l incharbuf 0 A[10:10]c
	.dbsym r i 22 I
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e getint _getint fc
;       intvalue -> R20
;         inchar -> R22
	.even
_getint::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 703
; }
; 
; char getint()
; {
	.dbline 706
; 	char intvalue,inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 707
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 708
; 	if(inchar==CR) return 0x78;
	cpi R22,13
	brne L256
X102:
	.dbline 708
	ldi R16,120
	xjmp L255
L256:
	.dbline 709
; 	intvalue = (inchar - '0')*10;
	ldi R24,10
	mul R24,R22
	mov R20,R0
	subi R20,224
	.dbline 710
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 711
; 	putcharr(inchar);	
	xcall _putcharr
	.dbline 712
; 	intvalue = intvalue + (inchar-'0');
	mov R24,R22
	subi R24,48
	add R20,R24
	.dbline 713
; 	return intvalue;
	mov R16,R20
	.dbline -2
L255:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r intvalue 20 c
	.dbsym r inchar 22 c
	.dbend
	.dbfunc e getsettime _getsettime fV
;         inchar -> R10
;         instrg -> y+6
	.even
_getsettime::
	st -y,R10
	st -y,R12
	sbiw R28,10
	.dbline -1
	.dbline 718
; }
; 
; // Update the current day and time
; void  getsettime()
; {
	.dbline 721
;     unsigned char instrg[4],inchar;
; 	
;     _CLI();
	cli
	.dbline 722
; 	instrg[0] = days;
	lds R2,_days
	std y+6,R2
	.dbline 723
; 	instrg[1] = hours;
	lds R2,_hours
	std y+7,R2
	.dbline 724
; 	instrg[2] = minutes;
	lds R2,_minutes
	std y+8,R2
	.dbline 725
; 	instrg[3] = seconds;
	lds R2,_seconds
	std y+9,R2
	.dbline 726
; 	_SEI();	
	sei
	.dbline 728
; 	
; 	printf("Set time [hh:mm:ss]=%d %d:%d:%d :",
	clr R3
	std y+5,R3
	std y+4,R2
	ldd R2,y+8
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+7
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+6
	clr R19
	ldi R16,<L262
	ldi R17,>L262
	xcall _printf
	.dbline 731
; 	   		instrg[0],instrg[1],instrg[2],instrg[3]);
; 
; 	if((instrg[1]=getint())==0x78) return;
	xcall _getint
	std y+7,R16
	cpi R16,120
	brne L266
X103:
	.dbline 731
	xjmp L258
L266:
	.dbline 732
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 732
	xcall _putcharr
	.dbline 733
; 	instrg[2] = getint();
	xcall _getint
	mov R12,R16
	std y+8,R12
	.dbline 734
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 734
	xcall _putcharr
	.dbline 735
; 	instrg[3] = getint();
	xcall _getint
	mov R12,R16
	std y+9,R12
	.dbline 736
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	mov R12,R16
	mov R10,R12
	.dbline 736
	xcall _putcharr
	.dbline 738
; 
;     _CLI();
	cli
	.dbline 739
; 	days = 0;
	clr R2
	sts _days,R2
	.dbline 740
; 	hours = instrg[1];
	ldd R2,y+7
	sts _hours,R2
	.dbline 741
; 	minutes = instrg[2];
	ldd R2,y+8
	sts _minutes,R2
	.dbline 742
; 	seconds = instrg[3];
	ldd R2,y+9
	sts _seconds,R2
	.dbline 743
; 	_SEI();	
	sei
	.dbline -2
L258:
	.dbline 0 ; func end
	adiw R28,10
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym l instrg 6 A[4:4]c
	.dbend
	.dbfunc e TestAVR _TestAVR fV
;              j -> R20
;              i -> R22
	.even
_TestAVR::
	xcall push_xgsetF000
	.dbline -1
	.dbline 748
; }
; 
; //  Simple test routine
; void TestAVR(void)
; {
	.dbline 751
;  	 char i,j;
; 	 
;  	 printf("\nTesting AVR Version 0.34\n");
	ldi R16,<L275
	ldi R17,>L275
	xcall _printf
	.dbline 756
; //	 TestAVRRAM();
; //	 TestAVREEPROM();
; //	 TestAVRFLASH();
; //	 TestBoardFLASH():
; 	 j = 0;
	clr R20
	.dbline 757
; 	 putcharr(' ');
	ldi R16,32
	xcall _putcharr
	.dbline 758
; 	 for(i=0x20; i<0x7f; i++) {
	ldi R22,32
	xjmp L279
L276:
	.dbline 758
	.dbline 759
; 	 	 putcharr(i);
	mov R16,R22
	xcall _putcharr
	.dbline 760
; 		 if(j++ == 60)  {
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R24,R2
	cpi R24,60
	brne L280
X104:
	.dbline 760
	.dbline 761
; 		     j = 0;
	clr R20
	.dbline 762
; 			 printf("\n ");
	ldi R16,<L282
	ldi R17,>L282
	xcall _printf
	.dbline 763
; 			 }
L280:
	.dbline 764
; 		 }
L277:
	.dbline 758
	inc R22
L279:
	.dbline 758
	cpi R22,127
	brlo L276
X105:
	.dbline 765
; 	 printf("\n ");
	ldi R16,<L282
	ldi R17,>L282
	xcall _printf
	.dbline 766
; 	 DumpAnalogChs();
	xcall _DumpAnalogChs
	.dbline -2
L274:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r j 20 c
	.dbsym r i 22 c
	.dbend
	.dbfunc e EEPROM_write _EEPROM_write fV
;         ucData -> R18
;      uiAddress -> R16,R17
	.even
_EEPROM_write::
	.dbline -1
	.dbline 770
; }
; 
; void  EEPROM_write(int uiAddress,unsigned char ucData)
; {
L284:
	.dbline 772
;     //  Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L285:
	.dbline 772
	sbic 0x1f,1
	rjmp L284
X106:
	.dbline 775
; 	
; 	// Set up address and Data registers
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 776
; 	EEDR = ucData;
	out 0x20,R18
	.dbline 779
; 	
; 	// Write logical one to EEMPE
; 	EECR |= (1<<EEMPE);
	sbi 0x1f,2
	.dbline 782
; 	
; 	// Start eeprom write by setting EEPE
; 	EECR |= (1<<EEPE);
	sbi 0x1f,1
	.dbline -2
L283:
	.dbline 0 ; func end
	ret
	.dbsym r ucData 18 c
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e EEPROM_read _EEPROM_read fc
;      uiAddress -> R16,R17
	.even
_EEPROM_read::
	.dbline -1
	.dbline 786
; }
; 
; unsigned char EEPROM_read(int uiAddress)
; {
L288:
	.dbline 788
;     // Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L289:
	.dbline 788
	sbic 0x1f,1
	rjmp L288
X107:
	.dbline 791
; 	
; 	// Setup address
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 794
; 	
; 	// Start eeprom read by writing EERE
; 	EECR |= (1<<EERE);
	sbi 0x1f,0
	.dbline 797
; 	
; 	// Return data from data register
; 	return EEDR;
	in R16,0x20
	.dbline -2
L287:
	.dbline 0 ; func end
	ret
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e WriteEepromSignature _WriteEepromSignature fV
	.even
_WriteEepromSignature::
	.dbline -1
	.dbline 802
; }
; 
; //  Signature bytes are write to first five EEPROM locations 85 C2 1E 4F 11
; void WriteEepromSignature(void)
; {
	.dbline 803
;     EEPROM_write(0,0x85);
	ldi R18,133
	clr R16
	clr R17
	xcall _EEPROM_write
	.dbline 804
;     EEPROM_write(1,0xC2);
	ldi R18,194
	ldi R16,1
	ldi R17,0
	xcall _EEPROM_write
	.dbline 805
;     EEPROM_write(2,0x1E);
	ldi R18,30
	ldi R16,2
	ldi R17,0
	xcall _EEPROM_write
	.dbline 806
;     EEPROM_write(3,0x4F);
	ldi R18,79
	ldi R16,3
	ldi R17,0
	xcall _EEPROM_write
	.dbline 807
;     EEPROM_write(4,0x11);
	ldi R18,17
	ldi R16,4
	ldi R17,0
	xcall _EEPROM_write
	.dbline -2
L291:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WriteEepromInt _WriteEepromInt fV
	.dbunion 1 2 u_tag
	.dbfield 0 iivalue I
	.dbfield 0 intchar A[2:2]c
	.dbend
;              u -> y+0
;         ivalue -> R10,R11
;        address -> R20,R21
	.even
_WriteEepromInt::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 811
; }
; 
; void WriteEepromInt(int address,int ivalue)
; {
	.dbline 817
;     union u_tag {
; 	    int iivalue;
; 		unsigned char intchar[2];
; 		} u;
; 	
; 	u.iivalue = ivalue;
	std y+1,R11
	std y+0,R10
	.dbline 818
;  	EEPROM_write(address++,u.intchar[0]);
	mov R18,R10
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 819
;  	EEPROM_write(address,u.intchar[1]);	
	ldd R18,y+1
	movw R16,R20
	xcall _EEPROM_write
	.dbline -2
L292:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[u_tag]
	.dbsym r ivalue 10 I
	.dbsym r address 20 I
	.dbend
	.dbfunc e WriteVersion _WriteVersion fV
	.even
_WriteVersion::
	.dbline -1
	.dbline 824
; }
; 
; // Write program version - offset address 5
; void WriteVersion(void)
; {
	.dbline 825
;     EEPROM_write(5,PRODUCTID);
	ldi R18,4
	ldi R16,5
	ldi R17,0
	xcall _EEPROM_write
	.dbline 826
; 	EEPROM_write(6,PROGRAMMAJORVER);
	clr R18
	ldi R16,6
	ldi R17,0
	xcall _EEPROM_write
	.dbline 827
; 	EEPROM_write(7,PROGRAMMINORVER);
	ldi R18,95
	ldi R16,7
	ldi R17,0
	xcall _EEPROM_write
	.dbline -2
L294:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WriteCopyright _WriteCopyright fV
;            ptr -> R20
	.even
_WriteCopyright::
	st -y,R20
	.dbline -1
	.dbline 832
; }
; 
; // Write copyright notice - offset address 8
; void WriteCopyright(void)
; {
	.dbline 835
;     unsigned char ptr;
; 	
; 	for(ptr=8; ptr<(8+strlen(version)); ptr++)
	ldi R20,8
	xjmp L299
L296:
	.dbline 836
;           EEPROM_write(ptr,version[ptr-8]);
	ldi R24,<_version-8
	ldi R25,>_version-8
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R16,R20
	clr R17
	xcall _EEPROM_write
L297:
	.dbline 835
	inc R20
L299:
	.dbline 835
	ldi R16,<_version
	ldi R17,>_version
	xcall _strlen
	movw R24,R16
	adiw R24,8
	mov R2,R20
	clr R3
	cp R2,R24
	cpc R3,R25
	brlo L296
X108:
	.dbline -2
L295:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r ptr 20 c
	.dbend
	.dbfunc e CheckEepromSignature _CheckEepromSignature fc
;         status -> R20
	.even
_CheckEepromSignature::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 842
; }
; 
; // Check 5 signature bytes in first five locations of EEPROM
; //   Should be 85 C2 1E 4F 11
; unsigned char CheckEepromSignature(void)
; {
	.dbline 845
;  	unsigned char status;
; 	
; 	status = 1;
	ldi R20,1
	.dbline 846
; 	if(EEPROM_read(0)!=0x85) status = 0;
	clr R16
	clr R17
	xcall _EEPROM_read
	cpi R16,133
	breq L302
X109:
	.dbline 846
	clr R20
L302:
	.dbline 847
; 	if(EEPROM_read(1)!=0xC2) status = 0;
	ldi R16,1
	ldi R17,0
	xcall _EEPROM_read
	cpi R16,194
	breq L304
X110:
	.dbline 847
	clr R20
L304:
	.dbline 848
; 	if(EEPROM_read(2)!=0x1E) status = 0;
	ldi R16,2
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,30
	breq L306
X111:
	.dbline 848
	clr R20
L306:
	.dbline 849
; 	if(EEPROM_read(3)!=0x4F) status = 0;
	ldi R16,3
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,79
	breq L308
X112:
	.dbline 849
	clr R20
L308:
	.dbline 850
; 	if(EEPROM_read(4)!=0x11) status = 0;
	ldi R16,4
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,17
	breq L310
X113:
	.dbline 850
	clr R20
L310:
	.dbline 851
; 	return status;
	mov R16,R20
	.dbline -2
L301:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r status 20 c
	.dbend
	.dbfunc e ReadEepromInt _ReadEepromInt fI
	.dbunion 1 2 u_tag
	.dbfield 0 ivalue I
	.dbfield 0 intchar A[2:2]c
	.dbend
;              u -> y+0
;        address -> R20,R21
	.even
_ReadEepromInt::
	xcall push_xgset300C
	movw R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 855
; }
; 
; int ReadEepromInt(int address)
; {	
	.dbline 861
;     union u_tag {
; 	    int ivalue;
; 		unsigned char intchar[2];
; 		} u;
; 	
; 	u.intchar[0] = EEPROM_read(address++);
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_read
	std y+0,R16
	.dbline 862
; 	u.intchar[1] = EEPROM_read(address);
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	std y+1,R10
	.dbline 863
; 	return u.ivalue;	
	ldd R16,y+0
	ldd R17,y+1
	.dbline -2
L312:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[u_tag]
	.dbsym r address 20 I
	.dbend
	.dbfunc e WriteEepromFloat _WriteEepromFloat fV
	.dbunion 1 4 u_tag
	.dbfield 0 ffvalue D
	.dbfield 0 floatchar A[4:4]c
	.dbend
;              u -> y+0
;         fvalue -> y+8
;        address -> R20,R21
	.even
_WriteEepromFloat::
	st -y,r19
	st -y,r18
	xcall push_xgsetF000
	movw R20,R16
	sbiw R28,4
	.dbline -1
	.dbline 867
; }
; 
; void  WriteEepromFloat(int address,float fvalue)
; {
	.dbline 873
;     union u_tag {
; 	    float ffvalue;
; 		unsigned char floatchar[4];
; 		} u;
; 	
; 	u.ffvalue = fvalue;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 874
;  	EEPROM_write(address++,u.floatchar[0]);
	ldd R18,y+0
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 875
;  	EEPROM_write(address++,u.floatchar[1]);
	ldd R18,y+1
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 876
;  	EEPROM_write(address++,u.floatchar[2]);
	ldd R18,y+2
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 877
;  	EEPROM_write(address,u.floatchar[3]);	
	ldd R18,y+3
	movw R16,R20
	xcall _EEPROM_write
	.dbline -2
L314:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF000
	adiw R28,2
	ret
	.dbsym l u 0 S[u_tag]
	.dbsym l fvalue 8 D
	.dbsym r address 20 I
	.dbend
	.dbfunc e ReadEepromFloat _ReadEepromFloat fD
	.dbunion 1 4 u_tag
	.dbfield 0 fvalue D
	.dbfield 0 floatchar A[4:4]c
	.dbend
;              u -> y+0
;        address -> R20,R21
	.even
_ReadEepromFloat::
	xcall push_xgsetF00C
	movw R20,R16
	sbiw R28,4
	.dbline -1
	.dbline 881
; }
; 
; float ReadEepromFloat(int address)
; {	
	.dbline 887
;     union u_tag {
; 	    float fvalue;
; 		unsigned char floatchar[4];
; 		} u;
; 	
; 	u.floatchar[0] = EEPROM_read(address++);
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_read
	std y+0,R16
	.dbline 888
; 	u.floatchar[1] = EEPROM_read(address++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	std y+1,R10
	.dbline 889
; 	u.floatchar[2] = EEPROM_read(address++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	std y+2,R10
	.dbline 890
; 	u.floatchar[3] = EEPROM_read(address);
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	std y+3,R10
	.dbline 891
; 	return u.fvalue;	
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	.dbline -2
L318:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF00C
	.dbsym l u 0 S[u_tag]
	.dbsym r address 20 I
	.dbend
	.dbfunc e LoadEepromPreferences _LoadEepromPreferences fV
;         inchar -> <dead>
;              i -> R22,R23
;     addressptr -> R20,R21
	.even
_LoadEepromPreferences::
	xcall push_xgsetF00C
	.dbline -1
	.dbline 896
; }
; 
; //  Load all the Motor Controller Setup preferences from EEPROM
; void LoadEepromPreferences()
; {
	.dbline 900
;     unsigned char inchar;
;     int addressptr,i;
; 	
; 	addressptr = 33;
	ldi R20,33
	ldi R21,0
	.dbline 903
; 	
; 	// I2C Configuration
; 	i2cmode = EEPROM_read(addressptr++);
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_read
	sts _i2cmode,R16
	.dbline 904
; 	TWI_slaveAddress = EEPROM_read(addressptr);
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	sts _TWI_slaveAddress,R10
	.dbline 905
; 	TWI_masterAddress = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _TWI_masterAddress,R10
	.dbline 908
; 	
; 	// General Setup parameters
; 	defaultlograte = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _defaultlograte+1,R11
	sts _defaultlograte,R10
	.dbline 908
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 909
; 	armpd2 = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _armpd2,R10
	.dbline 910
; 	if(armpd2==YES) SetBit(PORTD,PIND2);  // Activate pull up
	cpi R16,1
	brne L323
X114:
	.dbline 910
	sbi 0xb,2
L323:
	.dbline 911
; 	data2log = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _data2log,R10
	.dbline 912
; 	defaultaccelerometerrange = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _defaultaccelerometerrange,R10
	.dbline 913
; 	logoutputmode = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _logoutputmode,R10
	.dbline 914
; 	terminationmode = EEPROM_read(addressptr++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _terminationmode,R10
	.dbline 915
; 	timeoutperiod = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _timeoutperiod+1,R11
	sts _timeoutperiod,R10
	.dbline 915
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 918
; 	
; 	// Accelerometer calibration parameters
; 	xgmin = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _xgmin+1,R11
	sts _xgmin,R10
	.dbline 918
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 919
; 	xgmax = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _xgmax+1,R11
	sts _xgmax,R10
	.dbline 919
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 920
; 	xgmid = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _xgmid+1,R11
	sts _xgmid,R10
	.dbline 920
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 921
; 	ygmin = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _ygmin+1,R11
	sts _ygmin,R10
	.dbline 921
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 922
; 	ygmax = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _ygmax+1,R11
	sts _ygmax,R10
	.dbline 922
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 923
; 	ygmid = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _ygmid+1,R11
	sts _ygmid,R10
	.dbline 923
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 924
; 	zgmin = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _zgmin+1,R11
	sts _zgmin,R10
	.dbline 924
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 925
; 	zgmax = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _zgmax+1,R11
	sts _zgmax,R10
	.dbline 925
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 926
; 	zgmid = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R20
	xcall _ReadEepromInt
	movw R10,R16
	sts _zgmid+1,R11
	sts _zgmid,R10
	.dbline 926
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 929
; 	
; 	// Device id text message
; 	for(i=0; i<20; i++) deviceidtext[i] = EEPROM_read(addressptr++);
	clr R22
	clr R23
L325:
	.dbline 929
	movw R10,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R10
	xcall _EEPROM_read
	mov R10,R16
	ldi R24,<_deviceidtext
	ldi R25,>_deviceidtext
	movw R30,R22
	add R30,R24
	adc R31,R25
	std z+0,R10
L326:
	.dbline 929
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 929
	cpi R22,20
	ldi R30,0
	cpc R23,R30
	brlt L325
X115:
	.dbline -2
L322:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym l inchar 1 c
	.dbsym r i 22 I
	.dbsym r addressptr 20 I
	.dbend
	.dbfunc e SaveEepromPreferences _SaveEepromPreferences fV
;              i -> R22,R23
;     addressptr -> R20,R21
	.even
_SaveEepromPreferences::
	xcall push_xgsetF00C
	.dbline -1
	.dbline 934
; }
; 
; // Save controller configuration information to EEPROM
; void SaveEepromPreferences()
; {
	.dbline 937
;     int addressptr,i;
; 
; 	addressptr = 33;
	ldi R20,33
	ldi R21,0
	.dbline 940
; 
; 	// I2C Configuration
; 	EEPROM_write(addressptr++,i2cmode);
	lds R18,_i2cmode
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 942
; //	EEPROM_write(addressptr++,TWI_slaveAddress);
; 	EEPROM_write(addressptr++,TWI_masterAddress);
	lds R18,_TWI_masterAddress
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 945
; 
; 	// General Setup parameters
; 	WriteEepromInt(addressptr,defaultlograte); addressptr += 2;
	lds R18,_defaultlograte
	lds R19,_defaultlograte+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 945
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 946
; 	EEPROM_write(addressptr++,armpd2);
	lds R18,_armpd2
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 947
; 	EEPROM_write(addressptr++,data2log);
	lds R18,_data2log
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 948
; 	EEPROM_write(addressptr++,defaultaccelerometerrange);
	lds R18,_defaultaccelerometerrange
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 949
; 	EEPROM_write(addressptr++,logoutputmode);
	lds R18,_logoutputmode
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 950
; 	EEPROM_write(addressptr++,terminationmode);
	lds R18,_terminationmode
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 951
; 	WriteEepromInt(addressptr,timeoutperiod); addressptr += 2;	
	lds R18,_timeoutperiod
	lds R19,_timeoutperiod+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 951
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 954
; 	
; 	// Accelerometer calibration parameters
; 	WriteEepromInt(addressptr,xgmin); addressptr += 2;	
	lds R18,_xgmin
	lds R19,_xgmin+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 954
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 955
; 	WriteEepromInt(addressptr,xgmax); addressptr += 2;	
	lds R18,_xgmax
	lds R19,_xgmax+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 955
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 956
; 	WriteEepromInt(addressptr,xgmid); addressptr += 2;	
	lds R18,_xgmid
	lds R19,_xgmid+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 956
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 957
; 	WriteEepromInt(addressptr,ygmin); addressptr += 2;	
	lds R18,_ygmin
	lds R19,_ygmin+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 957
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 958
; 	WriteEepromInt(addressptr,ygmax); addressptr += 2;	
	lds R18,_ygmax
	lds R19,_ygmax+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 958
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 959
; 	WriteEepromInt(addressptr,ygmid); addressptr += 2;	
	lds R18,_ygmid
	lds R19,_ygmid+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 959
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 960
; 	WriteEepromInt(addressptr,zgmin); addressptr += 2;	
	lds R18,_zgmin
	lds R19,_zgmin+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 960
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 961
; 	WriteEepromInt(addressptr,zgmax); addressptr += 2;	
	lds R18,_zgmax
	lds R19,_zgmax+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 961
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 962
; 	WriteEepromInt(addressptr,zgmid); addressptr += 2;	
	lds R18,_zgmid
	lds R19,_zgmid+1
	movw R16,R20
	xcall _WriteEepromInt
	.dbline 962
	subi R20,254  ; offset = 2
	sbci R21,255
	.dbline 965
; 	
; 	// Store the device id text message
; 	for(i=0; i<20; i++) EEPROM_write(addressptr++,deviceidtext[i]);
	clr R22
	clr R23
L330:
	.dbline 965
	ldi R24,<_deviceidtext
	ldi R25,>_deviceidtext
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	movw R10,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R10
	xcall _EEPROM_write
L331:
	.dbline 965
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 965
	cpi R22,20
	ldi R30,0
	cpc R23,R30
	brlt L330
X116:
	.dbline -2
L329:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r i 22 I
	.dbsym r addressptr 20 I
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L282:
	.blkb 3
	.area idata
	.byte 10,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L275:
	.blkb 27
	.area idata
	.byte 10,'T,'e,'s,'t,'i,'n,'g,32,'A,'V,'R,32,'V,'e,'r
	.byte 's,'i,'o,'n,32,48,46,51,52,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L262:
	.blkb 34
	.area idata
	.byte 'S,'e,'t,32,'t,'i,'m,'e,32,91,'h,'h,58,'m,'m,58
	.byte 's,'s,93,61,37,'d,32,37,'d,58,37,'d,58,37,'d,32
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L234:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L233:
	.blkb 4
	.area idata
	.byte 37,'d,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L228:
	.blkb 23
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,32,'C,'h,'a,'n,'n,'e,'l,'s,32
	.byte 48,46,46,55,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L168:
	.blkb 3
	.area idata
	.byte 10,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L61:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L56:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
L51:
	.blkb 16
	.area idata
	.byte 'D,'e,'v,'i,'c,'e,32,'i,'d,58,32,37,'s,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_Utilities.c
; }
